// test.cpp : ̨Ӧóڵ㡣
//

//#include "stdafx.h"
// gdal
#include <gdal_version.h>
#include <ogrsf_frmts.h>
#include <iostream>

using namespace std;
#if GDAL_VERSION_MAJOR >= 2
#define  gdal_dataset_type  GDALDataset*;
#else
using gdal_dataset_type = OGRDataSource*;
#endif
int main(int argc, const char* argv[])
{
	
    char* pFile         = "d:/nanning.dxf";
	//char* pFile         = "d:/result.dxf";
    char* pNewFile      = "d:/result1.dxf";
	char* pNewFile2      = "d:/result2.dxf";

    GDALDriver*         pDriver     = NULL;
    GDALOpenInfo*       pInfo       = NULL;
    GDALDataset*        pDataset    = NULL;
    int                 iLayerCount =  0;


   
    OGRLayer*           pLayer      = NULL;
    OGRFeature*         pFeature    = NULL;
    OGRGeometry*        pGeometry   = NULL;

    GDALDataset*      pNewSource     = NULL;
	GDALDataset*      pNewSource2     = NULL;
    OGRwkbGeometryType  type;

	CPLSetConfigOption("GDAL_DATA","C:\\warmerda\\bld\\data");
	CPLSetConfigOption("DXF_WRITE_HATCH", "YES");
	 CPLSetConfigOption( "DXF_MERGE_BLOCK_GEOMETRIES", "TRUE" ) ;
	 CPLSetConfigOption( "DXF_INLINE_BLOCKS", "TRUE" );
    OGRRegisterAll();
    GDALAllRegister();
	CPLSetConfigOption("GDAL_FILENAME_IS_UTF8","NO");
	CPLSetConfigOption("DXF_ENCODING","GBK");
    
    //pDataset = (GDALDataset*)GDALOpen(pFile, GA_ReadOnly);
   
    pDriver = GetGDALDriverManager()->GetDriverByName("DXF");

#if GDAL_VERSION_MAJOR >= 2
   // gdal_dataset_type dataset_ = reinterpret_cast<gdal_dataset_type>(OGROpen(pFile, false, nullptr));

    unsigned int nOpenFlags = GDAL_OF_VECTOR;//GDAL_OF_READONLY | 
    const char* papszAllowedDrivers[] = { "DXF", nullptr };
   pDataset = reinterpret_cast<GDALDataset*>(GDALOpenEx(pFile,nOpenFlags,papszAllowedDrivers, nullptr, nullptr));
   
#else
    pDataset = OGRSFDriverRegistrar::Open(pFile, false);
#endif

    
//     if (pNewSource == NULL)
//     {
//         cout<<"Create DataSource failed!"<<endl;
//         return -1;
//     }
//     pNewSource->CopyLayer(pLayer,"new");
//     pNewSource->SyncToDisk();

//    OGROpen(pFile,0,pDriver);

    //if (NULL == pDriver)
    //{
    //    cout<<"Driver not avaiable!"<<endl;
    //    return -1;
    //}

    //pInfo = new GDALOpenInfo(pFile,0);
    //pDataset = pDriver->pfnOpen(pInfo);

    iLayerCount = pDataset->GetLayerCount();
    
    pLayer = pDataset->GetLayer(0);
    pLayer->ResetReading();
    type = pLayer->GetGeomType();

    int iFeatureCount = pLayer->GetFeatureCount();
    pLayer->ResetReading();

	pNewSource = pDriver->Create(pNewFile,0,0,0,GDT_Unknown, NULL);
	OGRLayer* pNewLayer = pNewSource->CreateLayer(pLayer->GetName(),pLayer->GetSpatialRef(),pLayer->GetGeomType(),NULL);

	pNewSource2 = pDriver->Create(pNewFile2,0,0,0,GDT_Unknown, NULL);
	//OGRLayer* pNewLayer2 = pNewSource->CreateLayer(pLayer->GetName(),pLayer->GetSpatialRef(),pLayer->GetGeomType(),NULL);
// 	OGRFeatureDefn* pFeaDef= pLayer->GetLayerDefn();
// 	for (int i=0;i<pFeaDef->GetFieldCount();++i)
// 	{
// 		OGRFieldDefn* pdef = pFeaDef->GetFieldDefn(i);
// 		pNewLayer->CreateField(pdef);
// 	}
	
	pNewSource2->CopyLayer(pLayer,pLayer->GetName(),NULL);


	pLayer->ResetReading();
	int nTemp=0;
	std::string strName;
    while((pFeature = pLayer->GetNextFeature()) != NULL)
    {
		
		
        //         OGRFeatureDefn * pFeaDef = pFeature->GetDefnRef();
        //         type = pFeaDef->GetGeomType();
//         pGeometry = pFeature->GetGeometryRef();
//         type = wkbFlatten(pGeometry->getGeometryType());
//         string stname = pGeometry->getGeometryName();
//         switch(type)
//         {
//         case wkbPoint:
//             cout<<"wkbPoint"<<endl;
//             break;
// 
//         case wkbLineString:
//             cout<<"wkbLineString"<<endl;
//             break;
// 
//         case wkbPolygon:
//             cout<<"wkbPolygon"<<endl;
//             break;
// 
//         case wkbMultiPoint:
//             cout<<"wkbMultiPoint"<<endl;
//             break;
// 
//         case wkbMultiLineString:
//             cout<<"wkbMultiLineString"<<endl;
//             break;
// 
//         case wkbMultiPolygon:
//             cout<<"wkbMultiPolygon"<<endl;
//             break;
// 
//         default:
//             cout<<"unknown"<<endl;
// 
//         }
		++nTemp;
		OGRErr err = pNewLayer->CreateFeature(pFeature);
		OGRFeatureDefn* pFeaDef = pFeature->GetDefnRef();
		for (int i=0;i<pFeaDef->GetFieldCount();++i)
		{
			OGRFieldDefn * pFddef = pFeaDef->GetFieldDefn(i);
			strName = pFddef->GetNameRef();
			cout<<strName<<endl;

		}
		OGRFeature::DestroyFeature(pFeature);
		pFeature = NULL;
    }
	

    //дļ
   // pNewSource = pDriver->CopyDataSource(pSource, pNewFile);
    //pNewSource->SyncToDisk();


    //pNewSource = pDriver->CreateDataSource("pNewFile", NULL);
    //if (pNewSource == NULL)
    //{
    //    cout<<"Create DataSource failed!"<<endl;
    //    return -1;
    //}
    //pNewSource->CopyLayer(pLayer,"new");
    //pNewSource->SyncToDisk();




    GDALClose(pNewSource);
	GDALClose(pDataset);
	GDALClose(pNewSource2);
//    OGRDataSource::DestroyDataSource(pSource);
    //GDALDataset pDataset; 
  

    //GDALDriverManager::GetDriverByName()



	return 0;
}

